

#define FALSE 0
#define TRUE  1

int btog(int binary)
{ return(binary ^ (binary >> 1));
}/* end of btog() */

int gtob(int gray)
{ int binary = gray;
  while((gray = (gray >>1))!= 0) binary ^= gray;
  return(binary);
}/* end of gtob() */


Matrix_Multiply(float *A, float *B, float *C, int m, int n, int p)
{ int i,j;

  for(i=0;i<m;i++)
     for(j=0;j<p;j++)
       for(k=0,C[i*m+j]=0;k<n;k++) C[i*m+j] = C[i*m+j] + A[i*m+k] * B[k*n+j];

}/* end of Matrix_Multiply() */

Matrix_Add(float *A, float *B, float *C, int m, int n)
{ int i,j;
  for(i=0;i<m;i++)
     for(j=0;j<n;j++)
	C[i*m+j] = A[i*m+j] + B[i*m+j];
}/* end of Matrix_Add() */

void get_my_Mesh_id(int *xid, int *yid, int my_id, int px)
{ int binid;
  binid=gtob(my_id);
  *yid=binid % px;
  *xid=binid / px;
}/* end of get_my_Mesh_id() */

get_Hyper_id(int x, int y, int px)
{ return(btog(y*px+x);
}/* end of get_Hyper_id() */

void Preconditioning(int px, int py)
{ int i,x,y,my_id;
  for(i=0;i<(px-1);i++)
  { get_my_Mesh_id(&x,&y,my_id,px);
    if(x>i) ; /* send a to get_Hyper_id((x-1+px)%px,y); */
  }/* end of for */
  for(i=0;i<(py-1);i++)
  { get_my_Mesh_id(&x,&y,my_id,px);
    if(y>i) ; /* send b to get_Hyper_id(x,(y-1+py)%py); */
  }/* end of for */
}/* end of Preconditioning() */

Parallel_Matrix_Multiply(int px, int py)
{ int bp,i,x,y;
  bp=px;
  if(py>px) bp=py;
  for(i=0;i<();i++)
  { c = c + a * b;
    get_my_Mesh_id(&x,&y,my_id,px);
    /* send a to get_Hyper_id((x-1+px)%px,y);
       send b to get_Hyper_id(x,(y-1+py)%py);
    */
  }/* end of for */

}/* end of Parallel_Matrix_Multiply() */

float random()
{
}/* end of random() */

produce_random(float *A, float *B, int dim)
{ int i;
  for(i=0;i<dim*dim;i++)
  { A[i] = random();
    B[i] = random();
  }/* end of for */
}/* end of produce_random() */

produce_matrix(float *A, float *B, float *C, int dim)
{ int retval=FALSE;
  if(A = calloc(dim*dim,sizeof(float)))
  { if(B = calloc(dim*dim,sizeof(float)))
    { if(C = calloc(dim*dim,sizeof(float)))
      { produce_random(A,B,dimen);
	retval=TRUE;
      }
      else { free(A); free(B);}
    }/* end of if */
    else free(A);
  }/* end of if */
}/* end of produce_matrix() */


main()
{ int MatrixDimen,HyperDimen;
  int px,py;

  printf("\n Enter Matrix dimension :");
  scanf(&MatrixDimen);

  printf("\n Enter Hypercube dimension :");
  scanf(&HyperDimen);

  /* calculate px,py */
  if(!(HyperDimen%2)) /* Hypercube dimension is even */
	 px=py=pow(2,HyperDimen/2);
  else { px = pow(2,(HyperDimen-1)/2);
	 py = 2 * px;
       }
  if(produce_matrix(A,B,C))
  {
  }
  else
    printf("\n We do not have enough memory to do this multiplication \n");

}/* end of main() */








